/*
 * LRParserTypes.h
 *
 *  Created on: 10. 5. 2016
 *	  Author: Martin Kocicka
 */

#ifndef LR_PARSER_TYPES_H_
#define LR_PARSER_TYPES_H_

#include <common/DefaultSymbolType.h>
#include <common/DefaultStateType.h>

#include <map>
#include <set>
#include <variant>
#include <vector>

namespace grammar {

namespace parsing {

enum class LRAction {
	Shift,
	Reduce,
	Accept
};

typedef ext::map < DefaultSymbolType, ext::set < ext::pair < unsigned, ext::vector < DefaultSymbolType > > > > LR0Items;
typedef ext::map < ext::pair < DefaultStateType, DefaultSymbolType >, ext::pair < LRAction, ext::variant < DefaultStateType, ext::pair < DefaultSymbolType, ext::vector < DefaultSymbolType > > > > > LRActionTable;
typedef ext::map < ext::pair < DefaultStateType, DefaultSymbolType >, DefaultStateType > LRGotoTable;

} /* namespace parsing */

} /* namespace grammar */

#endif /* LR_PARSER_TYPES_H_ */
